#include "config.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <badpenguin-ansi.h>
#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"
#include "set-proc-dir.h"


TBlockDevice *create_eide_device() {
  return calloc(1, sizeof(TBlockDevice));
}



TChain *query_eide_devices(TChain *devices ) {
  DIR *lpdir = NULL;
  struct dirent *lpdirent = NULL;
  TChainItem *pcurrent = NULL;
  FILE *fd = NULL;
  char *tempstr = NULL;
  tempstr  = calloc( 256, sizeof(char) );

  if ( initProc == 0 ) {
    set_proc_dir(DEFAULT_PROC_DIR, DEFAULT_DETECT_DIR );
  }
  
  // Clean Up previous Eide Chain
  if (devices!=NULL) {
    chain_cleanall(devices);
  } else {
    devices = chain_create();
  }

  // Controlla presenza di /proc/ide
  if ( 0 != file_exists(s_proc_eide) ) {
    printERROR("libhardware(EIDE): directory %s inesistente !\n", s_proc_eide );
    normal_color();
    return devices;
  }

  // Apre directory /proc/ide
  lpdir = opendir(s_proc_eide);
  if (lpdir==NULL) {    
    printERROR("libhardware(EIDE): impossibile aprire directory %s !\n", s_proc_eide );
    normal_color();
    return devices;
  }

  // Cerca nella directory ...
  lpdirent = readdir(lpdir);
  while (lpdirent!=NULL) {
    // ... i files con maschera '^hd*'
    if ( 0 == strncmp(lpdirent->d_name, "hd", 2 ) ) {

      // Alloca memoria per nuovo device
      //printf("trovato= %s \n", lpdirent->d_name );
      pcurrent = chain_append( devices );
      pcurrent->data = create_eide_device();
      // Assegna nome device
      pcurrent->name = calloc( 80, sizeof(char) );
      snprintf( pcurrent->name, 80, "/dev/%s", lpdirent->d_name );
      TBLOCKDEVICE(pcurrent->data)->device = strdup(pcurrent->name);

      // Lettura Modello periferica
      snprintf(tempstr, 256, "%s/%s/model", s_proc_eide, lpdirent->d_name );
      if ( 0 != file_exists(tempstr) ) {
        printERROR("libhardware(EIDE): impossibile aprire file %s\n", tempstr);
	normal_color();
        return devices;
      }
      fd = fopen(tempstr,"r");
      if (fd!=NULL) {
        read_line(fd, tempstr);
        fclose(fd);
        TBLOCKDEVICE(pcurrent->data)->model = strdup(tempstr);
      } else {
        TBLOCKDEVICE(pcurrent->data)->model = MODEL_UNKNOWN;
      }
      //printf("Model= %s\n", current->model );

      // Lettura Media periferica
      snprintf(tempstr, 256, "%s/%s/media", s_proc_eide, lpdirent->d_name );
      if ( 0 == file_exists(tempstr) ) {
        fd = fopen(tempstr,"r");
        if (fd==NULL) {
          printERROR("libhardware(EIDE): impossibile aprire file %s\n", tempstr);
	  normal_color();
          return devices;
        }
        read_line(fd, tempstr);
        fclose(fd);
        TBLOCKDEVICE(pcurrent->data)->media = strdup(tempstr);
      } else {
	TBLOCKDEVICE(pcurrent->data)->media = MEDIA_UNKNOWN;
      }
      //printf("Media= %s\n", current->media );
    }
    
    // Next file
    lpdirent = readdir(lpdir);
  }
  closedir(lpdir);
  return devices;
}
