#include "config.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <badpenguin-ansi.h>
#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"
#include "set-proc-dir.h"

#define KNOWN_NET_DEVICES	3

TPciDevice *create_net_device() {
  return calloc(1, sizeof(TNetDevice));
}

TChain *query_net_devices(TChain *devices) {
  TChainItem *pcurrent = NULL;
  TNetDevice *pdata = NULL;
  FILE *fd = NULL;
  char devmedia[KNOWN_NET_DEVICES][5] = { "lo", "eth0", "ppp0" };
  char *typemedia[KNOWN_NET_DEVICES] = { MEDIA_LO, MEDIA_ETH, MEDIA_PPP };
  char *tempstr = NULL;
  char *tempdata = NULL;
  int i;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );
  

  if ( initProc == 0 ) {
    set_proc_dir(DEFAULT_PROC_DIR, DEFAULT_DETECT_DIR );
  }

  if (devices!=NULL) {
    chain_cleanall(devices);
  } else {
    devices = chain_create();
  }

  if ( 0 != file_exists(s_proc_net) ) {
    printERROR("libhardware(NETWORK): directory %s inesistente !\n", s_proc_net);
    normal_color();
    return devices;
  }

  fd = fopen(s_proc_net_dev,"r");
  if (fd==NULL) {
    printERROR("libhardware(NETWORK): impossibile aprire file %s\n", s_proc_net_dev);
    normal_color();
    return devices;
  }

  // Cerca devices
  read_line(fd, tempstr);
  read_line(fd, tempstr);
  while (! feof(fd) ) {
    read_line(fd, tempstr);
    for (i=0; i<KNOWN_NET_DEVICES; i++) {
      if ( NULL != strstr(tempstr, devmedia[i])) {
        pcurrent         = chain_append(devices);
        pcurrent->name   = strdup(devmedia[i]);
        pcurrent->data   = create_net_device();
        pdata            = pcurrent->data;
        pdata->device    = strdup(pcurrent->name);
        pdata->media     = strdup(typemedia[i]);
        strncpy(tempdata, tempstr+7,8);
        pdata->RecvBytes = atol(tempdata);
        strncpy(tempdata, tempstr+66,8);
	pdata->SentBytes = atol(tempdata);
        //CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "ETH media" );
        if (isdigit(devmedia[i][strlen(devmedia[i])-1]))
          devmedia[i][strlen(devmedia[i])-1]++;
      
        //printf("Network device =%s\n", devmedia);
      }
    } 
  }
  // end parsing devices
  fclose(fd);
  return devices;
}
