#include "config.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"
#include "hardware.h"
#include "set-proc-dir.h"
#include "hexutils.h"

TChain *query_pci_devices (TChain *devices, int loiVerbose) {
  char laTempDir[256];
  char laTempFile[256];
  char buffer[256];
  DIR *dir1 = NULL;
  DIR *dir2 = NULL;
  struct dirent *lpdirent1 = NULL;
  struct dirent *lpdirent2 = NULL;
  TChainItem    *pciitem = NULL;
  TPciDevice    *mydevice = NULL;
  FILE          *fd = NULL;

  if ( initProc == 0 ) {
    set_proc_dir(DEFAULT_PROC_DIR, DEFAULT_DETECT_DIR );
  }

  // create pci chain
  if (devices != NULL) {
    chain_cleanall(devices);
  } else {
    devices = chain_create();
  }
  
  // Open main proc dir
  // Search for XX bus subdirs
  dir1 = opendir(s_bus_pci);
  if(dir1 == NULL) return NULL;
  
  for (lpdirent1 = readdir(dir1); lpdirent1 != NULL;
       lpdirent1 = readdir(dir1)) {    
    // Skip dot files
    if (lpdirent1->d_name[0] == '.')
      continue;
    // Check directory
    if ( 0 != is_directory(s_bus_pci,lpdirent1->d_name))
      continue;
    // Open the 00 subdirectory    
    if (loiVerbose>1) printf("Found dir: %s \n", lpdirent1->d_name );
    snprintf(laTempDir, sizeof(laTempDir), "%s/%s",
	     s_bus_pci, lpdirent1->d_name);
    //    
    dir2 = opendir(laTempDir);
    if (dir2 == NULL)
        continue;    
    lpdirent2 = readdir(dir2);
    for (lpdirent2 = readdir(dir2); lpdirent2 != NULL;
	 lpdirent2 = readdir(dir2)) {
      // Skip dot files
      if (lpdirent2->d_name[0] == '.')
        continue;
      // Check file
      if ( 0 != is_regularfile(laTempDir,lpdirent2->d_name))
        continue;
      // Process file
      if (loiVerbose>1) printf("Found pci: %s \n", lpdirent2->d_name );
      snprintf(laTempFile, sizeof(laTempFile), "%s/%s",
	       laTempDir, lpdirent2->d_name);
      // Read
      fd = fopen( laTempFile, "r" );
      if(fd == NULL) return NULL;
      fread( &buffer, 1, sizeof(buffer), fd );
      fclose(fd);
      // Allocate
      pciitem = chain_append(devices);
      mydevice = calloc(1, sizeof(TPciDevice));
      if(mydevice == NULL) return NULL;
      pciitem->data = mydevice;
      // Fill in
      mydevice->vendor   = getword(buffer+ PCI_VENDOR_ID);
      mydevice->device   = getword(buffer+ PCI_DEVICE_ID);
      mydevice->class    = buffer[PCI_CLASS_DEVICE+1];
      mydevice->subclass = buffer[PCI_CLASS_DEVICE];
      if (loiVerbose>0) printf("Device ..: %4x.%4x  %i.%i \n",
        mydevice->vendor, mydevice->device, mydevice->class, mydevice->subclass
      );
    }
  }
  return devices;
}
