#include "config.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <badpenguin-ansi.h>
#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"
#include "set-proc-dir.h"

TBlockDevice *create_scsi_device() {
  return calloc(1, sizeof(TBlockDevice));
}


TChain *query_scsi_devices(TChain *devices) {
  TChainItem *pcurrent = NULL;
  TBlockDevice *pdata = NULL;
  FILE *fd = NULL;
  char devmedia[3][10]= { "/dev/sda", "/dev/scd0",  "/dev/st0" };
  char *typemedia[3] = { MEDIA_DISK_SCSI, MEDIA_CDROM_SCSI , MEDIA_TAPE_SCSI };
  char *tempstr = NULL;
  char *tempdata = NULL;
  int i;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );
  

  if ( initProc == 0 ) {
    set_proc_dir(DEFAULT_PROC_DIR, DEFAULT_DETECT_DIR );
  }

  // Clean Up previous Eide Chain
  if (devices!=NULL) {
    chain_cleanall(devices);
  } else {
    devices = chain_create();
  }

  // Controlla presenza SCSI
  if ( 0 != file_exists(s_proc_scsi) ) {
    printERROR("libhardware(SCSI): directory %s inesistente !\n", s_proc_scsi );
    normal_color();
    return devices;
  }

  // Apre file SCSI
  fd = fopen(s_proc_scsi_scsi,"r");
  if (fd==NULL) {
    printERROR("libhardware(SCSI): impossibile aprire file %s\n", s_proc_scsi_scsi);
    normal_color();
    return devices;
  }

  // Cerca devices
  while (! feof(fd) ) {
    read_line(fd, tempstr);
    //printf(">%s\n", tempstr);
    
    // ... if vendore store it temporary
    if ( NULL != strstr(tempstr, "Vendor:")) {
      strncpy(tempdata, tempstr+10, 9);
      strncpy(tempdata+9, tempstr+26, 17 );
      tempdata[26]=0;
      //printf("VENDOR=%s\n", tempdata);
    } else
    if ( NULL != strstr(tempstr, "Type:")) {
      // Type checking: HARD DISKS or CDROM or TAPES
      for (i=0; i<3; i++) {
        if ( NULL != strstr(tempstr, typemedia[i])) {
          pcurrent 	   = chain_append(devices);
          pcurrent->name   = strdup(devmedia[i]);
          pcurrent->data   = create_scsi_device();
          pdata            = pcurrent->data;
          pdata->device    = strdup(pcurrent->name);
          pdata->model     = strdup(tempdata);
          pdata->media     = strdup(typemedia[i]);
	  //CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "SCSI media" );
          //probe_cfdisk(first, current->name);
	  // Increment scsi device name
	  devmedia[i][strlen(devmedia[i])-1]++;
          //printf("Scsi dev =%s\n", devmedia[i]);
        }
      } 
      // end parsing devices
    }
  }
  fclose(fd);
  return devices;
}
