
#include <stdio.h>
#include <string.h>

#include <badpenguin-chain.h>
#include "badpenguin-hardware.h"

int main(int argc, char** argv) {
  TChain *tux;
  TChainItem *c;
  TPciDevice *dev;
  
  /* Checking parameters
  int i;
  if (argc>1) {
    printf("- argc=%i \n", argc);
    for (i=1; i<argc; i++) {
      printf("%i, %s \n", i, argv[i] );
    }
  }
  */

  //printf("===== scanmodule.c =====\n");
  tux = NULL;
  tux = query_pci_devices(NULL,0);
  parse_pci_devices(tux);
  check_pci_devices(tux);
  c = tux->head;
  while (c!=NULL) {
    dev = TPCIDEVICE(c->data);
    if (dev->status >= MODULE_STATUS_GENERIC ) {
      printf( 
        "%-8s %-8s: %s %s (%4x:%4x) ", 
        dev->className, dev->kernelModule,
        dev->vendorName, dev->deviceName,
        dev->vendor, dev->device
      );
      switch (dev->status) {
        case MODULE_STATUS_RUNNING: {
	  printf( "running.\n" );
	  break;
	}
        case MODULE_STATUS_NOT_FOUND: {
	  printf( "not found.\n" );
	  break;
	}
        case MODULE_STATUS_UNSUPPORTED: {
	  printf( "unsupported.\n" );
	  break;
	}
        case MODULE_STATUS_GENERIC: {
	  printf( "generic.\n" );
	  break;
	}
        case MODULE_STATUS_DETECTED: {
	  printf( "detected.\n" );
	  break;
	}
        default: {
	  printf( "unknown\n" );
	  break;
	}
      }
    }
    c = c -> next;
  }

  // after probing load the modules
  if (argc>1) {
    if ( 0 == strcmp( argv[1], "--load" ) ) {
      c = tux->head;
      while (c!=NULL) {
        dev = TPCIDEVICE(c->data);
        load_pci_device(dev);
        c = c -> next;
      }
    }
  }

  return 0;
}
